//Global variables

var pieces=new Array(2);
var board=new Array(8);
var slotdivs=new Array(10);
var slotlabels=new Array(10);
var allmoves=new Array(16);
var timer=null; var MoveTimer=null;
var block_input=true;
var speed=4;
var white=true; var your_turn=true; var rocada1=true; var rocada2=true; var rocada3=true; var rocada4=true;
var enpassant=-1;
var moviecur="";
var moves=0; var move=0;
var curX=0; var curY=0; var curS=0;
var pasX=0; var pasY=0; var pasS=0;
var pozX=0; var pozY=0;
var Piece=null;
var piece_exchange=false;
var selected_piece=null;
var next_move=null;
var piese_sus=0; var piese_jos=0;
var load_save_status=null;

//Main functions

function _Board(culoare,nr,obj){
    this.culoare=culoare;
    this.nr=nr;
    this.obj=obj;
}
function CreatePiece(tip,culoare,nr,tooltip){
    pieces[culoare][nr]=mainarea.appendElement('<button image="images/pieces/piece_'+tip+'_'+culoare+'.png" x="-64" y="-64" tooltip="'+(culoare==0?"White ":"Black ")+tooltip+'" onmouseover="pieceOver('+culoare+','+nr+')" onmouseout="pieceOut('+culoare+','+nr+')" onclick="pieceClick('+culoare+','+nr+')" opacity="255" />');
}
function ApplySkin(x){
    if (x==0) x=Math.ceil(Math.random()*2);
    for (i=0;i<8;i++) for (j=0;j<8;j++){
        board[i][j].obj.image="images/skins/skin"+x+"/"+(i+j)%2+".png";
        board[i][j].obj.overImage="images/highlight.jpg";
    }
}
function InitializeVariables(){
    options.defaultValue("Skin")=0;
    options.defaultValue("Speed")=1;speed=2+options("Speed")*(options("Speed")+1);
    options.defaultValue("Slot1")="2w2A1";
    options.defaultValue("Slot2")="2w2A1";
    options.defaultValue("Slot3")="2w2A1";
    options.defaultValue("Slot4")="2w2A1";
    options.defaultValue("Slot5")="2w2A1";
    options.defaultValue("Slot6")="2w2A1";
    options.defaultValue("Slot7")="2w2A1";
    options.defaultValue("Slot8")="2w2A1";
    options.defaultValue("Slot9")="2w2A1";
	pieces[0]=new Array(16);
	pieces[1]=new Array(16);
	for (i=0;i<8;i++) board[i]=new Array(8);
	for (i=0;i<8;i++) for (j=0;j<8;j++) board[i][j]=new _Board(-1,-1,mainarea.appendElement('<button image="images/skins/skin'+(options("Skin")==0?1:options("Skin"))+'/'+(i+j)%2+'.png" overImage="images/highlight.jpg" x="'+(i*32+5)+'" y="'+(j*32+21)+'" onmouseover="boardOver('+i+','+j+')" onclick="boardClick('+i+','+j+')" />'));
	if (options("Skin")==0) ApplySkin(0);
	mainarea.appendElement('<button name="hl" image="images/highlight.jpg" width="32" heigth="32" x="-64" y="-64"/>');
	for (i=0;i<16;i++) CreatePiece("p",Math.floor(i/8),i%8,"Pawn");
	for (i=0;i<4;i++) CreatePiece("t",Math.floor(i/2),8+7*(i%2),"Rook");
	for (i=0;i<4;i++) CreatePiece("b",Math.floor(i/2),10+3*(i%2),"Bishop");
	for (i=0;i<2;i++) CreatePiece("q",i,11,"Queen");
	for (i=0;i<2;i++) CreatePiece("k",i,12,"King");
	for (i=0;i<4;i++) CreatePiece("h",Math.floor(i/2),9+5*(i%2),"Knight");
	for (i=0;i<10;i++){
	    slotdivs[i]=savearea.appendElement('<div onclick="slotClick('+i+')" cursor="hand" enabled="true" onmouseover="slotOver()" onmouseout="slotOut()" width="266" height="26" x="0" y="'+(i*26)+'"/>');
	    slotlabels[i]=slotdivs[i].appendElement('<label x="0" y="1" width="266" height="26" color="#000000" font="Arial" size="14" bold="true"></label>');
	}
	appendElement('<div name="divmesaj" width="266" height="266" x="0" y="16" enabled="false" onmouseover="divmesaj.enabled=false;ReduceMessageOpacity();"><label name="mesaj" width="266" height="266" size="36" font="times" color="#292760" align="center" valign="middle"></label></div>');
	for (i=0;i<16;i++) mainarea.appendElement('<div width="16" height="16" enabled="true" x="'+(16*i)+'" y="0" onmouseover="smallOver('+(16*i)+')" onmouseout="smallOut('+(16*i)+')" onclick="smallClick('+(16*i)+')"/>');
}
function MoveIt(){
	if (move>moves){
	    MoveTimer=null;Piece.x=pozX;Piece.y=pozY;Piece.width=Piece.height=(pasS>=0?32:16);
	    if (!friendsarea.visible){
	        selected_piece=null;
	        if (next_move!=null){
	            setTimeout(next_move,20);
	            next_move=null;
	        }else if (!piece_exchange){
	            block_input=your_turn;
	            your_turn=!your_turn;
	            if (your_turn) storeAllMoves();
	        }else{
	            block_input=!your_turn;
	            j=white?0:1;
	            ShowMessage(your_turn?"Chose a piece\nto replace\nyour pawn.":"Piece\nExchange");
	        }
	    }
	    return;
	}
	curS+=pasS;curX+=pasX;curY+=pasY
	Piece.width=Piece.height=Math.floor(curS);
	Piece.x=Math.floor(curX);Piece.y=Math.floor(curY);
	move++;
	MoveTimer=SetTimeout("MoveIt()",25);
}
function MovePiece(PieceNumber,color,newX,newY,instant){
    hl.x=hl.y=-64;
    if (!friendsarea.visible && !instant && !piece_exchange){
        if (your_turn && newY>=0 && (PieceNumber!=8 || (newX>0 && board[newX-1][newY].nr!=12) || newX==0) && (PieceNumber!=15 || (newX<7 && board[newX+1][newY].nr!=12) || newX==7)){
            for (i=0;i<8;i++) for (j=0;j<8;j++) board[i][j].obj.opacity=255;
            if (board[newX][newY].culoare>-1) next_move="MovePiece( "+board[newX][newY].nr+" , "+board[newX][newY].culoare+" , "+(piese_jos++)+" , -2 , false );";
            if (enpassant>-1 && PieceNumber<8 && newX==7-enpassant && newY==2) next_move="MovePiece( "+enpassant+" , "+board[newX][3].culoare+" , "+(piese_jos++)+" , -2 , false );";
            if (PieceNumber==12 && Math.abs((pieces[color][PieceNumber].x-5)/32-newX)==2) next_move="MovePiece( "+(newX<4?8:15)+" , "+color+" , "+(newX<4?newX+1:newX-1)+" , "+newY+" , false );";
            googleTalk.SendTalkData(friendUID,uniqueID+":move:"+PieceNumber+":"+color+":"+newX+":"+newY+":"+(instant?"1":"0")+":"+(next_move==null?"done":next_move));
            if (PieceNumber==12 || PieceNumber==8) rocada1=false;
            if (PieceNumber==12 || PieceNumber==15) rocada2=false;
        }
        if (!your_turn && (PieceNumber==12 || PieceNumber==8 || PieceNumber==15)){
            if (PieceNumber==8) rocada3=false;
            else if (PieceNumber==15) rocada4=false;
            else rocada3=rocada4=false;
        }
        if (PieceNumber<8 && (newY==0 || newY==7)){
            if ((newY==0 && piese_sus==0)||(newY==7 && piese_jos==0)) ShowMessage("Piece\nExchange\nImpossible"); else{
                savearea.visible=false;
                mainarea.opacity=255;
                piece_exchange=true;
            }
        }
    }
    if (piece_exchange && ((your_turn && newY==-1) || (!your_turn && newY==-2))){
        piece_exchange=false;
        j=white?0:1;
        if (your_turn) for (i=0;i<16;i++) if (pieces[j][i].width==20) pieces[j][i].width=pieces[j][i].height=16;
    }
    var oldx=(pieces[color][PieceNumber].x-5)/32;
    var oldy=(pieces[color][PieceNumber].y-21)/32;
    if (!friendsarea.visible && PieceNumber<8 && ((newY==3 && oldy==1) || (newY==4 && oldy==6))) enpassant=PieceNumber; else enpassant=-1;
	if (oldx>=0 && oldy>=0 && Math.floor(oldx)==oldx && Math.floor(oldy)==oldy && newY>=0) board[oldx][oldy].nr=board[oldx][oldy].culoare=-1;
	if (newY>=0) {board[newX][newY].nr=PieceNumber;board[newX][newY].culoare=color;}
	Piece=pieces[color][PieceNumber];
	pozX=newX*32+5;pozY=newY*32+21;pasS=0;
	if (newY<0) {pozX-=5;pozX/=2;pozY=-282*(newY+1);if (newY==-2) pozX+=16;}
	if (instant){
		if (newY<0) Piece.width=Piece.height=16; else Piece.width=Piece.height=32;
		Piece.x=pozX;Piece.y=pozY;return;
	}
 	if (pozX-Piece.x==0){
		pasX=0;pasY=(pozY-Piece.y)<0?-speed:speed;
		moves=Math.floor((pozY-Piece.y)/pasY);
	}else if (pozY-Piece.y==0){
	    pasY=0;pasX=(pozX-Piece.x)<0?-speed:speed;
		moves=Math.floor((pozX-Piece.x)/pasX);
	}else{
		if (Math.abs(pozX-Piece.x)>Math.abs(pozY-Piece.y)){
		  pasX=(pozX-Piece.x)<0?-speed:speed;
		  pasY=(pozY-Piece.y)/Math.abs(pozX-Piece.x)*speed;
		  moves=Math.floor((pozX-Piece.x)/pasX);
		}else{
			pasY=(pozY-Piece.y)<0?-speed:speed;
			pasX=(pozX-Piece.x)/Math.abs(pozY-Piece.y)*speed;
			moves=Math.floor((pozY-Piece.y)/pasY);
		}
	}
	if (newY<0) pasS=-16/moves;
	if (Piece.width==16) pasS=16/moves;
	curX=Piece.x;curY=Piece.y;curS=Piece.width;move=1;
	MoveIt();   
}
function SetStartingPosition(saved){
    piece_exchange=false;
    for (i=0;i<8;i++) for (j=0;j<8;j++) board[i][j].obj.opacity=255;
	for (i=0;i<16;i++){
	    MovePiece(i,white?0:1,i%8,6+Math.floor(i/8),true);
		MovePiece(i,white?1:0,7-i%8,1-Math.floor(i/8),true);
		pieces[0][i].height=pieces[0][i].width=pieces[1][i].height=pieces[1][i].width=32;
	}
	for (i=0;i<8;i++) for (j=2;j<6;j++) board[i][j].nr=board[i][j].culoare=-1;
	for (i=0;i<8;i++) {board[i][0].nr=15-i;board[i][1].nr=7-i;board[i][6].nr=i;board[i][7].nr=i+8;board[i][0].culoare=board[i][1].culoare=(white?1:0);board[i][6].culoare=board[i][7].culoare=(white?0:1);}
	MovePiece(11,1,white?3:4,white?0:7,true);
	MovePiece(12,1,white?4:3,white?0:7,true);
	if (white) {
	    board[3][0].culoare=1;board[3][0].nr=11;
	    UpLabel.innerText="B";DownLabel.innerText="W";
	}else{
	    board[4][7].culoare=1;board[4][7].nr=11;
	    UpLabel.innerText="W";DownLabel.innerText="B";
	}
	selected_piece=null;
	next_move=null;
	piese_sus=0;piese_jos=0;
	if (saved==""){
	    rocada1=rocada2=rocada3=rocada4=true;
        enpassant=-1;
    }else{
        i=saved.charCodeAt(0)-49;
        if (saved.charAt(i)=='w') your_turn=white; else your_turn=!white;
        block_input=!your_turn;
        j=saved.charCodeAt(i+1)-50;
        if (j>=8) {rocada1=true;j-=8;} else rocada1=false;
        if (j>=4) {rocada2=true;j-=4;} else rocada2=false;
        if (j>=2) {rocada3=true;j-=2;} else rocada3=false;
        rocada4=(j>=1);
        if (!white) {
            rocada4=rocada1;rocada1=rocada3;rocada3=rocada4;
            rocada4=rocada2;rocada2=(j>=1);
        }
        j=saved.charCodeAt(i+2)-50;
        var mywhite=(j>=16);
        enpassant=(j%16)-1;
        i+=3;
        for (j=0;j<64;j++){
            var aux=saved.charCodeAt(i+j)-50;
            var x=j%8; var y=Math.floor(j/8);
            if (white!=mywhite) {x=7-x;y=7-y;}
            if (aux>-1){
                board[x][y].nr=aux%16;
                board[x][y].culoare=Math.floor(aux/16);
                aux=pieces[board[x][y].culoare][board[x][y].nr];
                aux.x=x*32+5;
                aux.y=y*32+21;
            }else board[x][y].nr=board[x][y].culoare=-1;
        }
        aux=saved.substr(i+64,saved.length-i-64).split(" ");
        x=white==mywhite?0:-16;
        if (!white) x=-x;
        y=white?0:282;
        if (white){
            piese_sus=aux[0].length/2;
            if (aux.length>1) piese_jos=aux[1].length/2;
        }else{
            piese_jos=aux[0].length/2;
            if (aux.length>1) piese_sus=aux[1].length/2;
        }
        for (i=0;i<aux[0].length;i+=2){
            var j=aux[0].charCodeAt(i+1)-50;
            pieces[0][j].x=x+(aux[0].charCodeAt(i)-50)*16;
            pieces[0][j].y=y;
            pieces[0][j].width=pieces[0][j].height=16;
        }
        x=-x;y=282-y;
        if (aux.length>1){
            for (i=0;i<aux[1].length;i+=2){
                var j=aux[1].charCodeAt(i+1)-50;
                pieces[1][j].x=x+(aux[1].charCodeAt(i)-50)*16;
                pieces[1][j].y=y;
                pieces[1][j].width=pieces[1][j].height=16;
            }
        }
    }
	if (!friendsarea.visible && your_turn) storeAllMoves();
}
function SaveCurrentPosition(){
    var aux="";
    aux+=white?"w":"b";
    aux+=String.fromCharCode(50+(((white && rocada1)||(!white && rocada3))?8:0)+(((white && rocada2)||(!white && rocada4))?4:0)+(((white && rocada3)||(!white && rocada1))?2:0)+(((white && rocada4)||(!white && rocada2))?1:0),51+enpassant+(white?16:0));
    for (i=0;i<8;i++) for (j=0;j<8;j++) aux+=String.fromCharCode(board[j][i].nr+(board[j][i].culoare==1?16:0)+50);
    for (i=0;i<16;i++) if (pieces[0][i].width==16) aux+=String.fromCharCode(Math.floor(pieces[0][i].x/16)+50,i+50);
    aux+=" ";
    for (i=0;i<16;i++) if (pieces[1][i].width==16) aux+=String.fromCharCode(Math.floor(pieces[1][i].x/16)+50,i+50);
    return aux;
}
function DemoMatch(i){
	if (i>0 && MoveTimer!=null) {timer=setTimeout("DemoMatch("+i+")",1000);return;}
	if (i>=moviecur.length) {DemoMovie();return;}
	aux1=moviecur.charCodeAt(i)-50;
	aux2=moviecur.charCodeAt(i+1)-50;
	if (aux2<0){
		if (Math.floor(aux1/16)==0) aux3=(white?-1:-2); else aux3=(white?-2:-1);
		MovePiece(aux1%16,Math.floor(aux1/16),-1-aux2,aux3);
	}else MovePiece(aux1%16,Math.floor(aux1/16),Math.floor(aux2/8),aux2%8);
	timer=setTimeout("DemoMatch("+i+"+2)",2000);
}
function DemoMovie(){
	block_input=white=true;
	SetStartingPosition("");
	UpLabel.tooltip="Opponent";
	moviecur=storage.openText(storage.extract("matches/match"+Math.ceil(Math.random()*3)+".txt"));
	DemoMatch(0);
}
function ConfirmLoad(aux,x){
    i=aux.charCodeAt(0)-50;
    j=aux.charAt(i+1);
    var aux2="Game name : "+(aux.substr(1,i))+"\nNext player to move : "+(j=='w'?"white":"black")+"\n----------------------------------------\nCastle moves status :\n                queen side           king side\nwhite :   "+((white?rocada1:rocada3)?" still possible  ":"already done")+"     "+((white?rocada2:rocada4)?" still possible  ":"already done")+"\nblack  :   "+((white?rocada4:rocada2)?" still possible  ":"already done")+"     "+((white?rocada3:rocada1)?" still possible  ":"already done")+"\n--------------------------------------------------\nYou can see the board layout in the game area.";
    if (confirm(aux2)){
        LoadGame.innerText="Slot "+x;
        LoadGame.tooltip="Loads the "+(aux.substr(1,i))+" game, stored in Slot"+x+" to play with a friend you choose.";
        ShowMessage("Slot "+x+"\nselected");
        friendsarea.opacity=255;
        mainarea.opacity=50;
        savearea.visible=false;
        DemoMovie();
    }else{
        load_save_status="load";
        mainarea.opacity=50;
        savearea.visible=true;
    }
}
function ConfirmEnemyLoad(aux,name,id,color){
    i=aux.charCodeAt(0)-50;
    j=aux.charAt(i+1);
    var aux2=name+" wants to play a saved game of chess with you.\nThe game details are listed below :\nGame name : "+(aux.substr(1,i))+"\nYou will play with : "+color+"\nNext player to move : "+(j=='w'?"white":"black")+"\n----------------------------------------\nCastle moves status :\n                queen side           king side\nwhite :   "+((white?rocada1:rocada3)?" still possible  ":"already done")+"     "+((white?rocada2:rocada4)?" still possible  ":"already done")+"\nblack  :   "+((white?rocada4:rocada2)?" still possible  ":"already done")+"     "+((white?rocada3:rocada1)?" still possible  ":"already done")+"\n--------------------------------------------------\nYou can see the board layout in the game area.\n\nWould you like to play with him now ?\n(refusing will allow you to add a reason).\nKeep in mind that any game in progress will be forfeited !";
    if (confirm(aux2)){
        friendUID = id;
	    googleTalk.SendTalkData(friendUID,uniqueID+":accept:"+(color=="white"?"black":"white")+":"+aux.length+":"+aux);
	    your_turn=white=(color=="white"?true:false);
	    block_input=!white;
		UpLabel.tooltip=name;
        changeView(false);
        SetStartingPosition(aux);
    }else{
        var answer=utils.prompt("Give "+name+" a reson for refusing...","I am currently busy");
        if (!answer) {ConfirmEnemyLoad(aux,name,id,color);return;}
        changeView(true);
		googleTalk.SendTalkData(id,uniqueID+":decline-reason:"+answer);
    }
}

//Event functions

function pieceOver(culoare,nr){
	if (block_input || piece_exchange || pieces[culoare][nr].width<32) {event.returnValue=false;return;}
	if (!piece_exchange) board[(pieces[culoare][nr].x-5)/32][(pieces[culoare][nr].y-21)/32].obj.image="images/highlight.jpg";
}
function pieceOut(culoare,nr){
    if (piece_exchange) {event.returnValue=false;return;}
    try{
	    var x=(pieces[culoare][nr].x-5)/32;
	    var y=(pieces[culoare][nr].y-21)/32;
	    board[x][y].obj.image=board[(x>1?x-2:x+2)][y].obj.image;
    }catch(e){}
}
function pieceClick(culoare,nr){
	if (block_input || piece_exchange || (culoare!=(white?0:1) && selected_piece==null) || pieces[culoare][nr].width<32) {event.returnValue=false;return;}
	if (selected_piece==null){
	    selected_piece=culoare*16+nr;
	    hl.x=pieces[culoare][nr].x;
	    hl.y=pieces[culoare][nr].y;
	    for (i=0;i<8;i++) for (j=0;j<8;j++) board[i][j].obj.opacity=100;
	    for (i=0;i<allmoves[nr].length;i+=2) board[allmoves[nr].charCodeAt(i)-48][allmoves[nr].charCodeAt(i+1)-48].obj.opacity=255;
	}else{
	    var x=(pieces[culoare][nr].x-5)/32;
	    var y=(pieces[culoare][nr].y-21)/32;
	    if (board[x][y].obj.opacity==255){
	        MovePiece(selected_piece%16,Math.floor(selected_piece/16),x,y,false);
	        block_input=true;
	    }else{
	        selected_piece=null;
	        hl.x=-64;
	        hl.y=-64;
	        for (i=0;i<8;i++) for (j=0;j<8;j++) board[i][j].obj.opacity=255;
	        pieceClick(culoare,nr);
	    }
	}
}
function boardOver(x,y){
	if (block_input || piece_exchange) {event.returnValue=false;return;}
}
function boardClick(x,y){
	if (block_input || piece_exchange || (board[x][y].culoare!=(white?0:1) && selected_piece==null)) {event.returnValue=false;return;}
	if (selected_piece==null){
	    selected_piece=board[x][y].culoare*16+board[x][y].nr;
	    hl.x=board[x][y].obj.x;
	    hl.y=board[x][y].obj.y;
	    for (i=0;i<8;i++) for (j=0;j<8;j++) board[i][j].obj.opacity=100;
	    for (i=0;i<allmoves[board[x][y].nr].length;i+=2) board[allmoves[board[x][y].nr].charCodeAt(i)-48][allmoves[board[x][y].nr].charCodeAt(i+1)-48].obj.opacity=255;
	}else{
	    if (board[x][y].obj.opacity==255){
	        MovePiece(selected_piece%16,Math.floor(selected_piece/16),x,y,false);
	        block_input=true;
	    }else{
	        selected_piece=null;
	        hl.x=-64;
	        hl.y=-64;
	        for (i=0;i<8;i++) for (j=0;j<8;j++) board[i][j].obj.opacity=255;
	        boardClick(x,y);
	    }
	}
}
function smallOver(x){
    if (!piece_exchange || !your_turn || x>=piese_sus*16) return;
    var col=white?0:1;
    for (i=0;i<16;i++) if (pieces[col][i].width==16) if (pieces[col][i].x==x){
        pieces[col][i].width=pieces[col][i].height=24;
        return;
    }
}
function smallOut(x){
    if (!piece_exchange || !your_turn || x>=piese_sus*16) return;
    var col=white?0:1;
    for (i=0;i<16;i++) if (pieces[col][i].width==24) if (pieces[col][i].x==x){
        pieces[col][i].width=pieces[col][i].height=16;
        return;
    }
}
function smallClick(x){
    if (!piece_exchange || block_input || !your_turn || x>=piese_sus*16) return;
    var col=white?0:1;
    for (i=0;i<16;i++) if (pieces[col][i].width<32) if (pieces[col][i].x==x){
        for (j=0;j<8;j++) if (board[j][0].nr<8 && board[j][0].nr>-1){
	        next_move="MovePiece( "+board[j][0].nr+" , "+col+" , "+(x/16)+" , -1 , false );";
            googleTalk.SendTalkData(friendUID,uniqueID+":move:"+i+":"+col+":"+j+":0:0:"+next_move);
            MovePiece(i,col,j,0,false);
	        return;
	    }
	    return;	
    }
}
function slotOver(){
	event.srcElement.background = "#ccccff";
}
function slotOut(){
	event.srcElement.background = "";
}
function slotClick(x){
    if (x==0){
        if (load_save_status=="load"){
            LoadGame.innerText="New Game";
            LoadGame.tooltip="Starts a new game with the player you choose.";
            ShowMessage("New Game\nselected");
            changeView(true);
        }else if (load_save_status=="quit") changeView(true);
        else mainarea.opacity=255;
        load_save_status=null;savearea.visible=false;event.returnValue=false;return;
    }
    var aux=options("Slot"+x);
    if (aux.charCodeAt(0)==50 && load_save_status=="load") {event.returnValue=false;return;}
    if (aux.charCodeAt(0)>50 && load_save_status!="load") if (!confirm("Are you sure you want to overwrite the "+aux.substr(1,aux.charCodeAt(0)-50)+" slot ?")) {event.returnValue=false;return;}
    if (load_save_status=="load"){
        SetStartingPosition(aux);
        mainarea.opacity=255;
        mesaj.opacity=0;
        setTimeout("ConfirmLoad('"+aux+"',"+x+")",50);
    }else{
        var s=utils.prompt("Please give a name for this game...\n(Please use a maximum of 10 letters or it will be truncated)","saved game");
        if (!s) {event.returnValue=false;return;}
        if (s.length>10) s=s.substr(0,10);
        options("Slot"+x)=String.fromCharCode(s.length+50)+s+SaveCurrentPosition();
        ShowMessage("Game Saved");
        mainarea.opacity=255;
    }
    savearea.visible=false;
    if (load_save_status=="quit") changeView(true);
    load_save_status=null;
}
function Quit(){
    if (confirm("Are you sure you want to quit this game ?")){
        if (friendUID!=null) googleTalk.SendTalkData(friendUID,uniqueID+":quit");
        friendUID=null;
		changeView(true);
    }
}
function Load_Save(status){
    ReduceMessageOpacity();
    if (load_save_status==status){
        slotClick(0);
        event.returnValue=false;return;
    }
    load_save_status=status;
    slotlabels[0].innerText=(status=="load"?"New Game":status=="save"?"<- Return":"<- Just Quit");
    if (status=="load"){
        if (timer!=null) clearInterval(timer);
	    if (MoveTimer!=null) clearInterval(MoveTimer);
	}
	friendsarea.opacity=0;
    for (i=1;i<10;i++) {
        var s=options("Slot"+i);
        slotlabels[i].innerText="Slot "+i+" : "+(s.substr(1,s.charCodeAt(0)-50));
    }
    mainarea.opacity=50;
    savearea.visible=true;
}

//Main program entry point

InitializeVariables();
changeView(true);